Midpoint or centre of an interval (if we ignore rounding):
  ⌊ a mid b ⌋ = ⌊ (a + b) /2⌋ and ⌈ a mid b ⌉ = ⌈ (a +b) /2⌉
NB. ⌊ (a + b) /2⌋ is the arithmetic mean of a and b.

-------------------------------------------------------------------------------

\begin{code}
{-# OPTIONS --without-K --safe #-}

module VFP.Natural.Midpoint where

open import VFP.Natural public
\end{code}

-------------------------------------------------------------------------------

Floor of midpoint.

<<mid>>
\begin{code}
⌊_mid_⌋ : ℕ -> ℕ -> ℕ
⌊ zero    mid b       ⌋ = ⌊ b /2⌋
⌊ succ a  mid zero    ⌋ = ⌊ succ a /2⌋
⌊ succ a  mid succ b  ⌋ = succ ⌊ a mid b ⌋
\end{code}

. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

Ceiling of midpoint.

\begin{code}
⌈_mid_⌉ : ℕ -> ℕ -> ℕ
⌈ zero   mid b      ⌉ = ⌈ b /2⌉
⌈ succ a mid zero   ⌉ = ⌈ succ a /2⌉
⌈ succ a mid succ b ⌉ = succ ⌈ a mid b ⌉
\end{code}

-------------------------------------------------------------------------------
