Identity function and function composition.

-------------------------------------------------------------------------------

\begin{code}
{-# OPTIONS --without-K --safe #-}

module VFP.Function where

private
  variable
    A B C : Set
\end{code}

-------------------------------------------------------------------------------

\begin{code}
identity : A → A
identity = λ a → a

infixr 9 _∘_ _；_
_∘_ : (B → C) → (A → B) → (A → C)
g ∘ f = λ a → g (f a)

_；_ : (A → B) → (B → C) → (A → C)
f ； g = λ a → g (f a)
\end{code}

\begin{code}
private
  identity′  : (A : Set) -> A -> A
  identity′ A a = a

  test′ : (A : Set) -> A -> A
  test′ A = identity′ (A -> A) (identity′ A)
\end{code}

\begin{code}
  identity″ : {A : Set} -> A -> A
  identity″ a = a

  test″ : {A : Set} -> A -> A
  test″ = identity″ identity″
\end{code}

\begin{code}
  identity‴ : ∀ {A : Set} -> A -> A
  identity‴ a = a
\end{code}

-------------------------------------------------------------------------------
