Properties of midpoint for specific to ≺₇.

-------------------------------------------------------------------------------

\begin{code}
{-# OPTIONS --without-K --safe #-}

module VFP.Natural.Midpoint.Properties-7 where

open import VFP.Natural.Midpoint public
open import VFP.Natural.Midpoint.Properties renaming (⌊mid⌋-left to ⌊mid⌋-left₀;
                                                      ⌊mid⌋-right to ⌊mid⌋-right₀;
                                                      ⌈mid⌉-left to ⌈mid⌉-left₀;
                                                      ⌈mid⌉-right to ⌈mid⌉-right₀)
open import VFP.Natural.Order.Properties-7
open import VFP.Natural.Order.Interrelations using ()
                                          renaming (to-≺₇ to to-≺;
                                                    fro-≺₇ to fro-≺;
                                                    to-≼₇ to to-≼;
                                                    fro-≼₇ to fro-≼)

private variable
  a b : ℕ
\end{code}

-------------------------------------------------------------------------------

<<mid-left-right-sig>>
\begin{code}
a≺a-mid-b  : 1 +  a ≺ b -> a ≺ ⌊ a mid b ⌋
a-mid-b≺b  :      a ≺ b -> ⌊ a mid b ⌋ ≺ b
\end{code}

\begin{code}
a≺a-mid-b p = to-≺ (⌊mid⌋-left₀ (fro-≺ p))
a-mid-b≺b p = to-≺ (⌊mid⌋-right₀ (fro-≺ p))
\end{code}

. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

\begin{code}
⌈mid⌉-left : a ≺ b -> a ≺ ⌈ a mid b ⌉
⌈mid⌉-left p = to-≺ (⌈mid⌉-left₀ (fro-≺ p))

⌈mid⌉-right : succ a ≺ b -> ⌈ a mid b ⌉ ≺ b
⌈mid⌉-right p = to-≺ (⌈mid⌉-right₀ (fro-≺ p))
\end{code}
