Properties of midpoint.

-------------------------------------------------------------------------------

\begin{code}
{-# OPTIONS --without-K --safe #-}

module VFP.Natural.Midpoint.Properties where

open import VFP.Natural.Midpoint public
open import VFP.Natural.Order.Properties

private variable
  a b : ℕ
\end{code}

-------------------------------------------------------------------------------

\begin{code}
⌊mid⌋-left : succ a ≺ b -> a ≺ ⌊ a mid b ⌋
⌊mid⌋-left (succ≺succ zero≺succ)     = zero≺succ
⌊mid⌋-left (succ≺succ (succ≺succ p)) = succ≺succ (⌊mid⌋-left (succ≺succ p))

⌊mid⌋-right : a ≺ b -> ⌊ a mid b ⌋ ≺ b
⌊mid⌋-right (zero≺succ)   = ⌈n/2⌉≺succ-n _
⌊mid⌋-right (succ≺succ p) = succ≺succ (⌊mid⌋-right p)
\end{code}

. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

\begin{code}
⌈mid⌉-left : a ≺ b -> a ≺ ⌈ a mid b ⌉
⌈mid⌉-left (zero≺succ)   = zero≺succ
⌈mid⌉-left (succ≺succ p) = succ≺succ (⌈mid⌉-left p)

⌈mid⌉-right : succ a ≺ b -> ⌈ a mid b ⌉ ≺ b
⌈mid⌉-right (succ≺succ zero≺succ)     = succ≺succ (⌈n/2⌉≺succ-n _)
⌈mid⌉-right (succ≺succ (succ≺succ p)) = succ≺succ (⌈mid⌉-right (succ≺succ p))
\end{code}

-------------------------------------------------------------------------------
